using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;

namespace AAO_algoritmusok
{
    class aao_alg
    {
        public static int fibo(int i)
        {
            if (i == 0)
            { Console.WriteLine(i); return 0; }
            else if (i == 1) { Console.WriteLine(i); return 1; }
            else Console.WriteLine(i);
            return fibo(i - 1) + fibo(i - 2);

        }

        public static void fibo2(int n)
        {
            n =int.Parse(Console.ReadLine());  // tmbmret adott
            long[] f = new long[n];  // Fibonacci szmok gyorsan nnek
            f[0] = 0; f[1] = 1;
            for (int i = 2; i < n; i++) f[i] = f[i - 1] + f[i - 2];
        }

        /*public static void fibo3(int n)
        {
            int i; int value;
            n = int.Parse(Console.ReadLine());
            ArrayList fiblist = new ArrayList();
            fiblist.Add(0); fiblist.Add(1);
            for (i = 2; value <= n; i++)
            {
                int[] tomb = new int[fiblist.Count];
                fiblist.CopyTo(tomb);
                value = tomb[i - 1] + tomb[i - 2];
                fiblist.Add(value);
            }
            Console.WriteLine(n + " . fibo= " + fiblist[--i]);
            Console.ReadLine();


        }*/


        public static int euklidesz(int a, int b)
        {
            int t, a1, b1;
            a1 = Math.Max(a, b);
            b1 = Math.Min(a, b);
            while (a1 != b1)
            {
                if (a1 > b1) a1 = a1 - b1;
                else { t = a1; a1 = b1; b1 = t; }
            }
            Console.WriteLine(a1);
            return a1;

        }

        public static int gcd(int a, int b)
        {
            int t;
            while (b != 0)
            {
                t = b; b = a % b; a = t;
            }
            Console.WriteLine(a);

            return a;

        }

        public static int rgcd(int a, int b)
        {
            return (b == 0 ? a : gcd(b, a % b));
        }


        public static void heron(double x1, double y1, double x2,
                                         double y2, double x3, double y3)
        {
            double s, d1, d2, d3, T;
            d1 = Math.Sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));
            d2 = Math.Sqrt((x2 - x3) * (x2 - x3) + (y2 - y3) * (y2 - y3));
            d3 = Math.Sqrt((x1 - x3) * (x1 - x3) + (y1 - y3) * (y1 - y3));

            s = (d1 + d2 + d3) / 2.0;
            /*return Math.Sqrt(s * (s - d1) * (s - d2) * (s - d3));*/
            T = Math.Sqrt(s * (s - d1) * (s - d2) * (s - d3));
            Console.WriteLine("Terlet: " + T);
        }

        public static double heron2(double x1, double y1, double x2,
                                         double y2, double x3, double y3)
        {
            double s, d1, d2, d3;
            d1 = Math.Sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));
            d2 = Math.Sqrt((x2 - x3) * (x2 - x3) + (y2 - y3) * (y2 - y3));
            d3 = Math.Sqrt((x1 - x3) * (x1 - x3) + (y1 - y3) * (y1 - y3));

            s = (d1 + d2 + d3) / 2.0;
            return Math.Sqrt(s * (s - d1) * (s - d2) * (s - d3));
            /*T = Math.Sqrt(s * (s - d1) * (s - d2) * (s - d3));
            Console.WriteLine("Terlet: " + T);*/
        }

        static void Main(string[] args)
        {
            Console.BackgroundColor = System.ConsoleColor.Black;
            Console.ForegroundColor = System.ConsoleColor.Green;
            for (int i = 0; i < 70; i++)
            {
                Console.Write('-');
            }
            Console.WriteLine();
            Console.WriteLine("AAO algoritmusok implementcii");
            Console.WriteLine();
            for (int i = 0; i < 70; i++)
            {
                Console.Write('-');
            }
            Console.WriteLine();
            int dr;
            Console.WriteLine("Vlassz a kvetkezk kzl: ");
            Console.WriteLine("1. msodfok");
            Console.WriteLine("2. kzelt gykvons");
            Console.WriteLine("3. terletszmts Heron kplettel");
            Console.WriteLine("4. 0-kbl s 1-esekbl ll sorozat rendezse sszehasonltssal");
            Console.WriteLine("5. 0-kbl s 1-esekbl ll sorozat rendezse sszehasonlts nlkl");
            Console.WriteLine("6. sokszg terlet kiszmtsa");
            Console.WriteLine("7. legnagyobb kzs oszt kiszmtsa euklidszi, simn, vagy rekurzv mdon");
            Console.WriteLine("8. Fibonacci sorozat gy-gy-amgy");
            Console.WriteLine("0. kilps");
            dr = int.Parse(Console.ReadLine());
            switch (dr)
            {

                case 1:


                    double a, b, c, gy, x1, x2;
                    byte gomb;
                    Console.WriteLine("rd be 'a'-t");
                    a = double.Parse(Console.ReadLine());
                    Console.WriteLine("rd be 'b'-t");
                    b = double.Parse(Console.ReadLine());
                    Console.WriteLine("rd be 'c'-t");
                    c = double.Parse(Console.ReadLine());
                    x1 = 0.0;
                    x2 = 0.0;

                    if (a == 0)
                    {
                        if (b == 0)
                        {
                            if (c == 0)
                            {
                                gomb = 4;
                            }
                            else
                            {
                                gomb = 5;
                            }
                        }
                        else
                        {
                            gomb = 6; x1 = -c / b;
                        }
                    }
                    else
                    {
                        gy = b * b - 4 * a * c;
                        if (gy < 0)
                        {
                            gomb = 1;
                        }
                        else
                        {
                            gomb = 2;
                            gy = Math.Sqrt(b * b - 4 * a * c);
                            if (gy == 0)
                            {
                                x1 = -b / (2 * a);
                            }
                            else
                            {
                                gomb = 3;
                                x1 = (-b + gy) / (2 * a);
                                x2 = (-b - gy) / (2 * a);
                            }
                        }
                    }

                    switch (gomb)
                    {
                        case 1: Console.Write("nincs vals megolds"); break;
                        case 2: Console.Write("egy megolds van " + x1); break;
                        case 3: Console.Write("kt megolds van x1:" + x1 + " s x2:" + x2); break;
                        case 4: Console.Write("minden vals szm megolds"); break;
                        case 5: Console.Write("nincs megolds"); break;
                        case 6: Console.Write("elfajult: " + x1); break;

                    }
                    Console.ReadLine();
                    break;

                case 2:


                    double inp, ujgy, gy2, d, eps;
                    gy2 = 1.0;
                    d = 1.0;
                    eps = 0.00001;
                    inp = double.Parse(Console.ReadLine());
                    while (d > eps)
                    {
                        ujgy = (1.0 / 2) * (gy2 + inp / gy2);
                        d = Math.Abs(ujgy - gy2);
                        ujgy = gy2;
                    }
                    Console.WriteLine(gy2);
                    Console.ReadLine();
                    break;

                case 3:

                    double ix1, ix2, ix3, ips1, ips2, ips3;

                    Console.WriteLine("add meg x1-et");
                    ix1 = double.Parse(Console.ReadLine());
                    Console.WriteLine("add meg x2-t");
                    ix2 = double.Parse(Console.ReadLine());
                    Console.WriteLine("add meg x3-at");
                    ix3 = double.Parse(Console.ReadLine());
                    Console.WriteLine("add meg y1-et");
                    ips1 = double.Parse(Console.ReadLine());
                    Console.WriteLine("add meg y2-t");
                    ips2 = double.Parse(Console.ReadLine());
                    Console.WriteLine("add meg y3-at");
                    ips3 = double.Parse(Console.ReadLine());

                    heron(ix1, ips1, ix2, ips2, ix3, ips3);
                    Console.ReadLine();
                    break;

                case 4:

                    int i;
                    int[] b2 = { 0, 0, 1, 0, 1, 1, 0, 0, 1, 0, 1, 0, 0, 1, 1, 0 };
                    for (i = 0; i < b2.Length; i++) Console.Write(b2[i] + "  ");
                    Console.WriteLine();

                    int n = b2.Length; int[] b1 = new int[i];   // b1 segdtmb
                    for (i = 0; i < n - 1; i++)   // b1 vgre rakjuk az 1-ket
                        if (b2[i] == 1) b1[--n] = b2[i];  // fontos, hogy --j s nem j--
                    if (b2.Length > 0) b1[--n] = b2[i];     // az utolst mr gy is lehet!
                    else Console.WriteLine("a tmb res!");
                    for (i = 0; i < b2.Length; i++) Console.Write(b1[i] + "  ");
                    Console.WriteLine("ez lett rendezs utn");
                    Console.ReadLine();

                    break;

                case 5:

                    int v = 0;
                    int szum = 0;
                    int[] b3 = { 0, 0, 1, 0, 1, 1, 0, 0, 1, 0, 1, 0, 0, 1, 1, 0 };
                    /* megszmoljuk, hny 1-es van*/
                    for (v = 0; v < b3.Length; v++) szum += b3[v];
                    /* b3 elejt kell szm nullval feltltjk*/
                    for (v = 0; v < b3.Length - szum; v++) b3[v] = 0;
                    /*b3 vgt feltltjk annyi 1-essel, amennyivel kell*/

                    for (int j = v; j < b3.Length; j++) b3[j] = 1;

                    for (int y = 0; y < b3.Length; y++) Console.Write(b3[y] + " ");

                    Console.ReadLine();

                    break;

                case 6:

                    double[] tomb = new double[] { 1.0, 0.0, 0.0, 2.0, -1.0, 0.0, 0.0, -3.0 };
                    double x4, y4, x5, y5, x6, y6, h = 0.0;
                    int m = tomb.Length;
                    x4 = tomb[0]; y4 = tomb[1];
                    for (int k = 2; k + 3 < m; k = k + 2)
                    {
                        x5 = tomb[k]; y5 = tomb[k + 1];
                        x6 = tomb[k + 2]; y6 = tomb[k + 3];
                        h += heron2(x4, y4, x5, y5, x6, y6);
                    }
                    Console.WriteLine("terulet: " + h);
                    Console.ReadLine();

                    break;


                case 7:

                    int elso, masodik;
                    Console.WriteLine("rd be az els osztt");
                    elso = int.Parse(Console.ReadLine());
                    Console.WriteLine("rd be a msodikat");
                    masodik = int.Parse(Console.ReadLine());
                    Console.WriteLine("vlassz megint: 'e' euklidesz; 'g' sima, 'r' rekurzv; 'k' kilp");
                    char cs = char.Parse(Console.ReadLine());
                    switch (cs)
                    {
                        case 'e':

                            euklidesz(elso, masodik);
                            Console.ReadLine();
                            break;

                        case 'g':
                            gcd(elso, masodik);
                            Console.ReadLine();
                            break;

                        case 'r':
                            rgcd(elso, masodik);
                            Console.ReadLine();
                            break;

                        case 'k':
                            break;
                    }

                    break;

                case 8:

                    int first;
                    Console.WriteLine("----------------------------------");
                    Console.WriteLine("Hanyadik fibonaccsiszmot keresed?");
                    first = int.Parse(Console.ReadLine());
                    Console.WriteLine("Vlassz a kvetkezk kzl:");
                    Console.WriteLine("r - Fibonacci rekurzvan");
                    Console.WriteLine("f - Fibonacci tmbbel ha mret fix");
                    Console.WriteLine("n - Fibonacci tmmbel ha mret nem fix");
                    Console.WriteLine("s - Fibonacci segdvltozkkal");
                    Console.WriteLine("z - Fibonacci zrt alakban (kplettel)");
                    Console.WriteLine("q - kilp");
                    char ch2 = char.Parse(Console.ReadLine());

                    switch (ch2)
                    {
                        case 'r':
                            fibo(first);
                            Console.ReadLine();
                            break;

                        case 'f':
                            Console.WriteLine("Add meg a tmb mrett");
                            fibo2(first);
                            Console.ReadLine();
                            break;

                        case 'n':
                            
                            int value = 0; int k;
                            //int f = int.Parse(Console.ReadLine());
                            ArrayList fiblist = new ArrayList();
                            fiblist.Add(0); fiblist.Add(1);
                            for (k = 2; value <= first; k++)
                            {
                                int[] tombi = new int[fiblist.Count];
                                fiblist.CopyTo(tombi);
                                value = tombi[k - 1] + tombi[k - 2];
                                fiblist.Add(value);
                            }
                            Console.WriteLine(first + " . fibonacci szm= " + fiblist[--k]);
                            

                            Console.ReadLine();
                            break;

                        case 's':
                            int y = 0, seged0 = 0, seged1 = 1, f = 0;
                            //Console.Write("Keressk az n-dikFibonacci szmot, ahol n= ");
                            if (first == 0) Console.WriteLine("A vlasz 0");
                            else if (first == 1) Console.WriteLine("A vlasz 1");
                            else
                            {
                                for (y = 2; y <= first; y++)
                                {
                                    f = seged0 + seged1;
                                    seged0 = seged1;
                                    seged1 = f;
                                }
                                Console.WriteLine("f= " + f);
                            }

                            Console.ReadLine();
                            break;

                        case 'z':
                            int fib;
                            //Console.Write("Hanyadik Fibonacci szmot szmtsuk: ");
                            //double n -> first
                            double gyot = Math.Sqrt(5.0);
                            fib = (int)Math.Truncate(
                                                (1.0 / gyot) * (Math.Pow(((1.0 + gyot) / 2.0), first) -
                                                                   Math.Pow(((1.0 - gyot) / 2.0), first)
                                                                 )
                                            );

                            Console.WriteLine("Az eredmny:" + fib);

                            Console.ReadLine();
                            break;

                        case 'q':
                            Console.WriteLine("Bye! Bye!\a");
                            System.Threading.Thread.Sleep(100);

                            break;
                    }
                    break;

                case 0:
                    Console.WriteLine("Bye! Bye!\a");
                    System.Threading.Thread.Sleep(100);
                    break;


            }
        }
    }
}
